(function (global, $) {
  var
  $menu = $("#menu-list"),
  $galleryName = $("#gallery-name"),
  $photos = $("#photos"),
  $detail = $("#photo-detail"),
  $detailImg = $("#photo-detail .img"),
  $detailDesc = $("#photo-detail .desc"),
  $detailPrev = $("#photo-detail .prev"),
  $detailNext = $("#photo-detail .next"),
  $detailClose = $("#photo-detail .close");

  $.getJSON("http://192.168.2.222/api/json/index", function (data) {
    var lis = [];

    for (var i = 0; i < data.length; ++i) {
      var item = data[i];

      var li = document.createElement("li");
      li.innerHTML = item.name;
      li.galleryId = item.id;
      li.onclick = loadGallery;

      $menu.append(li);
      lis.push(li);
    }

    loadGallery.call(lis[Math.floor(Math.random() * lis.length)]);
  });

  var block, count, imgs;
  function loadGallery() {
    if (block) return;
    block = true;

    $galleryName.html(this.innerHTML);
    $.getJSON("http://192.168.2.222/api/json/" + this.galleryId, function (data) {
      $photos.empty();
      count = data.length;
      imgs = [];

      for (var i = 0; i < data.length; ++i) {
        var item = data[i];

        var div = document.createElement("div");
        div.className = "img";
        div.galleryIndex = i;
        div.galleryUrl = item.url;
        div.galleryDescription = item.description;
        div.onclick = showImage;

        var img = new Image();
        img.src = item.url;
        div.appendChild(img);

        if (item.description) {
          var desc = document.createElement("div");
          desc.className = "description";
          desc.innerHTML = "<span>" + item.description + "</span>";
          div.appendChild(desc);
        }

        $photos.append(div);
        imgs.push(div);
      }

      block = false;
    });
  }

  var visible;
  function showImage() {
    setImage(this);

    $detail.fadeIn(100);
    visible = true;
  }
  var currentIndex;
  function setImage(div) {
    $detailImg.empty();
    var img = new Image();
    img.src = div.galleryUrl;
    currentIndex = div.galleryIndex
    $detailImg.append(img);

    $detailDesc.html(div.galleryDescription || "");

    var start;
    $(img)
      .on("mousedown", function (e) {
        start = e.clientX;
        e.preventDefault();
      })
      .on("mouseup", function (e) {
        var end = e.clientX;

        if (start !== undefined) {
          var m = end - start;
          if (m > 30) {
            changeImage(-1);
          }
          else if (m < -30) {
            changeImage(1);
          }
        }
      })
      .on("click", function (e) {
        e.stopPropagation();
      });
  }

  function fullscreen(enable) {
    var
    el = $detail[0],
    on = el.requestFullscreen || el.mozRequestFullScreen || el.msRequestFullscreen || el.webkitRequestFullscreen,
    off = document.exitFullscreen || document.mozCancelFullScreen || document.webkitExitFullscreen || document.msExitFullscreen;

    if (enable) {
      if (on) on.call(el);
    }
    else {
      if (off) off.call(document);
    }
  }

  $detail.on("click", exitImage);
  $(document).on("keyup", function (e) {
    if (!visible) return;

    console.log(e.which);

    switch (e.which) {
      case 70:
        fullscreen(true);
        break;
      case 37:
        changeImage(-1);
        break;
      case 39:
        changeImage(1);
        break;
      case 27:
        exitImage();
        break;
    }
  });

  function changeImage(n) {
    var index = currentIndex + n;
    if (index < 0) index += count;
    if (index >= count) index -= count;

    setImage(imgs[index]);
  }

  function exitImage() {
    $detail.fadeOut(100);
    fullscreen(false);
    visible = false;
  }

  $detail.on("mousedown", function (e) {
    e.preventDefault();
  });

  $detailPrev.on("click", function (e) {
    e.stopPropagation();
    changeImage(-1);
  });
  $detailNext.on("click", function (e) {
    e.stopPropagation();
    changeImage(1);
  });
})(this, $);
